import * as React from "react";
import {
    Week, Month, Agenda, ScheduleComponent, ResourcesDirective,
    ResourceDirective, ViewsDirective, ViewDirective, Inject, Resize, DragAndDrop
} from "@syncfusion/ej2-react-schedule";

/** import styles section */
import "../node_modules/@syncfusion/ej2-base/styles/material.css";
import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
import "../node_modules/@syncfusion/ej2-calendars/styles/material.css";
import "../node_modules/@syncfusion/ej2-dropdowns/styles/material.css";
import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";
import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
import "../node_modules/@syncfusion/ej2-schedule/styles/material.css";
import "./App.css";

interface testInterface {
    eventsArray: any
}

export class Ap extends React.Component<testInterface> {
    public state: any = { newData: false };
    public eventsData: any = [];
    private resourceData: Object[] = [
        { AirlineName: 'Alice', AirlineId: 1, AirlineColor: '#EA7A57' },
        { AirlineName: 'Smith', AirlineId: 2, AirlineColor: '#357cd2' },
        { AirlineName: 'Nancy', AirlineId: 3, AirlineColor: '#7fa900' }
    ];

    private dateHeaderTemplate(): JSX.Element {
        return (<div>Customer</div>
        );
    }

    private resourceHeaderTemplate(props: any): JSX.Element {
        return (<div style={{ backgroundColor: props.resourceData.AirlineColor }}>{props.resourceData.AirlineName.slice(0, 1)}</div>
        );
    }

    public schDate: Date = new Date(2018, 3, 1);
    public dateHeader: any = this.dateHeaderTemplate.bind(this);
    public resourceHeader: any = this.resourceHeaderTemplate.bind(this);
    public grp: any = { byDate: true, resources: ['Airlines'] };

    public render() {
        const prop: any = this.props;

        return (
            <div>
                <ScheduleComponent cssClass='schedule-group' width='100%' height='650px' selectedDate={this.schDate}
                    eventSettings={{
                        dataSource: prop.eventsArray, fields: {
                            subject: { title: 'Travel Summary', name: 'Subject' },
                            location: { title: 'Source', name: 'Location' },
                            description: { title: 'Comments', name: 'Description' },
                            startTime: { title: 'Departure Time', name: 'StartTime' },
                            endTime: { title: 'Arrival Time', name: 'EndTime' }
                        }
                    }}
                    group={this.grp} dateHeaderTemplate={this.dateHeader}
                    resourceHeaderTemplate={this.resourceHeader}>
                    <ResourcesDirective>
                        <ResourceDirective field='AirlineId' title='Airline Name' name='Airlines' allowMultiple={true}
                            dataSource={this.resourceData} textField='AirlineName' idField='AirlineId' colorField='AirlineColor'>
                        </ResourceDirective>
                    </ResourcesDirective>
                    < ViewsDirective >
                        <ViewDirective option='Week' />
                        <ViewDirective option='Month' />
                        <ViewDirective option='Agenda' />
                    </ViewsDirective>
                    <Inject services={[Week, Month, Agenda, Resize, DragAndDrop]} />
                </ScheduleComponent>
            </div>
        );
    }
}
export { Ap as default }